Setting up shared VNC on OpenSuse 11

Hi,

I’m trying to set up a shared VNC server configuration where the session is kept alive even if the VNC client closes the connection. I had this running on a 10.2 box, but fail to get it going on 11. Here’s the section from /etc/xinetd.d/vnc (based on some instructions I found elsewhere).

service vnc2
{
	type		= UNLISTED
	disable		= no
	socket_type     = stream
	protocol        = tcp
	wait            = yes
	user            = root
	server          = /usr/bin/Xvnc
	server_args     = -inetd -query localhost -geometry 1220x960 -depth 16 -once -DisconnectClients=0 -NeverShared passwordFile=/root/.vncpasswd
	port		= 5902
}

Client-Connection fails and /var/log/messages says

Aug  8 13:14:52 gandalf xinetd[3780]: warning: can't get client address: Transport endpoint is not connected

a couple of times and then

Aug  8 13:14:52 gandalf xinetd[3585]: Deactivating service vnc2 due to excessive incoming connections.  Restarting in 10 seconds.

I do have

*     # any host can get a login window

in my Xaccess.

Any ideas ?

thx,
Hugo

Having pretty much the same issue on 10.3 since updating to the latest version yesterday. Not much else in the logs to tell me what’s wrong either.
in xinetd wait = no fixes the problem ,but then the session is ended whenever you disconnect.
Running Xvnc standalone on the command line works fine too.

I’d consider creating a service and running it without xinetd, but don’t have the time to figure out how to write my own service scripts :slight_smile:

Well, I really need this, so here’s my flavor of an xvnc start script. Copy into /etc/init.d, adjust the params in line 119, run insserv, deactivate xvnc in xineted and activate the new script in the run level editor. Works fine for me on OpenSuse 11.

(I’ve cut some comments from the original sekelton so that it fits into the post limits here)

#!/bin/sh
#
#     Template SUSE system startup script for example service/daemon XVNC
#     Copyright (C) 1995--2005  Kurt Garloff, SUSE / Novell Inc.
#          
#     This library is free software; you can redistribute it and/or modify it
#     under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation; either version 2.1 of the License, or (at
#     your option) any later version.
#			      
#     This library is distributed in the hope that it will be useful, but
#     WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#      
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#     USA.
#
# /etc/init.d/xvnc
#   and its symbolic link
# /(usr/)sbin/rcxvnc
#
# Template system startup script for XVNC
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
# 
# Note: This template uses functions rc_XXX defined in /etc/rc.status on
# UnitedLinux/SUSE/Novell based Linux distributions. If you want to base your
# script on this template and ensure that it works on non UL based LSB 
# compliant Linux distributions, you either have to provide the rc.status
# functions from UL or change the script to work without them.
# See skeleton.compat for a template that works with other distros as well.
#
### BEGIN INIT INFO
# Provides:          xvnc
# Required-Start:    $network $xdm
# Should-Start:
# Required-Stop:
# Should-Stop:
# Default-Start:     5
# Default-Stop:      0 1 2 6
# Short-Description:  Xvnc Server
# Description:       Start persistent Xvnv Server
### END INIT INFO
# 
# Any extensions to the keywords given above should be preceeded by 
# X-VendorTag- (X-UnitedLinux- X-SuSE- for us) according to LSB.
# 

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance

XVNC_BIN="/usr/bin/Xvnc"

test -x $XVNC_BIN || { echo "$XVNC_BIN not installed"; 
	if  "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Check for existence of needed config file and read it
#FOO_CONFIG=/etc/sysconfig/FOO
#test -r $FOO_CONFIG || { echo "$FOO_CONFIG not existing";
#	if  "$1" = "stop" ]; then exit 0;
#	else exit 6; fi; }
#
## Read config	
#. $FOO_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset


# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

export LANG=C
export LC_ALL=C

case "$1" in
    start)
	echo -n "Starting Xvnc "
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	startproc $XVNC_BIN -noreset -once -query localhost -geometry 1220x960 -depth 16 -rfbport 5800 :1
	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting Xvnc "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.
	killproc Xvnc

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart the service if it
	## is running.

	echo -n "Reload service XVNC "
	## if it supports it:
	/sbin/killproc -HUP $XVNC_BIN
	#touch /var/run/XVNC.pid
	rc_status -v

	## Otherwise:
	#$0 try-restart
	#rc_status
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signaling, do nothing (!)

	# If it supports signaling:
	echo -n "Reload service XVNC "
	/sbin/killproc -HUP $XVNC_BIN
	#touch /var/run/XVNC.pid
	rc_status -v
	
	## Otherwise if it does not support reload:
	#rc_failed 3
	#rc_status -v
	;;
    status)
	echo -n "Checking for service XVNC "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	/sbin/checkproc $XVNC_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload, print out the
	## argument to this init script which is required for a reload.
	## Note: probe is not (yet) part of LSB (as of 1.9)

	test /etc/XVNC/XVNC.conf -nt /var/run/XVNC.pid && echo reload
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit

Thanx for the script HG, but after creating the script file, when i use the command activate xxxxx (filename), an error message displays stating: “not a block device”.
What can be the cause of that?